routes/web.php
<?php

use Illuminate\Support\Str;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('landing_page');
})->name('landing');

Auth::routes(['verify' => true]);

// Routes for the users/members are defined here
Route::middleware(['auth'])->group(function () {
    Route::namespace('Member')->group(function () {
        Route::get('dashboard', 'MemberController@dashboard')->name('dashboard'); //->middleware('verified');

        Route::get('invoices', 'MemberController@getInvoices');
        Route::get('invoices/{code}', 'MemberController@getInvoiceDetail')->name('invoices.detail');
        Route::get('invoices/generate/{code}', 'MemberController@getInvoiceGenerate')->name('invoices.generate');

        Route::get('payment/{code}', 'MemberController@showPaymentPage');
        Route::post('payment/upload-receipt', 'MemberController@uploadPaymentReceipt');

        Route::get('profile', 'ProfileController@index')->name('member.profile');
        Route::post('profile/update', 'ProfileController@updateProfile')->name('member.update');
        Route::post('profil/update-avatar', 'ProfileController@saveAvatar');

        Route::get('transactions', 'TransactionController@index');

        Route::post('notifications/mark-as-read', 'MemberController@markNotification');
    });
});

// Routes for the admin are defined here
Route::prefix('admin')->namespace('Admin')->group(function () {
    Route::match(['get', 'post'], 'login', 'AuthController@login')->middleware('guest');
    Route::middleware(['auth:admin'])->group(function () {
        Route::get('dashboard', 'AdminDashboardController@index');
        Route::get('logout', 'AuthController@logout')->name('admin.logout');
        Route::resource('garbage-categories', 'GarbageCategoryController');
        Route::resource('hamlets', 'HamletController');

        Route::get('members', 'AdminController@indexMembers')->name('members.index');
        Route::get('members/detail/{id}', 'AdminController@getMemberDetails')->name('members.detail');
        Route::get('members/data', 'AdminController@getMembersData');
        Route::post('members/change-status', 'AdminController@changeMemberStatus');
        Route::get('members/count', 'AdminController@countMembers');
        // Route::post('members/delete/{id}', 'AdminController@destroyMember');

        Route::post('invoices/delete/{id}', 'InvoiceController@destroy');
        Route::get('invoices/data', 'InvoiceController@getData');
        Route::get('invoices/count', 'InvoiceController@count');
        Route::get('invoices/download/{code}', 'InvoiceController@downloadInvoice')->name('invoices.download');
        Route::post('invoices/confirm/{id}', 'InvoiceController@confirmPaymentManual')->name('invoices.confirm');

        Route::resource('invoices', 'InvoiceController');

        Route::get('transactions', 'TransactionController@index')->name('transactions.index');
        Route::get('transactions-data', 'TransactionController@getData');
        Route::get('transactions/count', 'TransactionController@count');
        Route::post('transactions/change-status', 'TransactionController@changeStatus');

        Route::resource('target-members', 'TargetMemberController');

        Route::get('report', 'ReportController@index')->name('report.index');
        Route::get('report-data', 'ReportController@getData');
        Route::get('report/export', 'ReportController@exportReport');

        Route::get('setting/banks', 'SettingController@indexBank')->name('setting.banks.index');
        Route::get('setting/banks/create', 'SettingController@createBank')->name('setting.banks.create');
        Route::post('setting/banks/create', 'SettingController@storeBank')->name('setting.banks.store');
        Route::get('setting/banks/edit/{id}', 'SettingController@editBank')->name('setting.banks.edit');
        Route::post('setting/banks/update/{id}', 'SettingController@updateBank')->name('setting.banks.update');
        Route::post('setting/banks/delete/{id}', 'SettingController@destroyBank')->name('setting.banks.destroy');

        Route::post('notifications/mark-as-read', 'AdminController@markNotification');
    });
});

Route::middleware(['auth:admin', 'superadmin'])->namespace('Admin')->prefix('super-admin')->group(function () {
    Route::get('admins', 'SuperAdminController@indexAdmins')->name('admin.index');
    Route::get('admins/create', 'SuperAdminController@createAdmin')->name('admin.create');
    Route::post('admins', 'SuperAdminController@storeAdmin')->name('admin.store');
    Route::post('admins/delete/{id}', 'SuperAdminController@destroyAdmin')->name('admin.destroy');
});

app/Models/Hamlet.php
<?php

namespace App\Models;

use App\User;
use App\Models\TargetMember;
use Illuminate\Database\Eloquent\Model;

class Hamlet extends Model
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'hamlet_name'

    ];

    /**
     * Get the user that owns the hamlet.
     */
    public function user()
    {
        return $this->belongsTo(User::class);
    }

    /**
     * Get the user that owns the hamlet.
     */
    public function targetMember()
    {
        return $this->hasOne(TargetMember::class);
    }
}

app/Http/Controllers/Admin/HamletController.php
<?php

namespace App\Http\Controllers\Admin;

use App\User;
use App\Models\Hamlet;
use App\Models\TargetMember;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Session;

class HamletController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $hamlets = Hamlet::all();
        return view('admin.hamlets.index', compact('hamlets'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.hamlets.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        DB::transaction(function () use($request) {
            $hamlet = Hamlet::create([
                'hamlet_name' => $request->hamlet_name
            ]);

            TargetMember::create([
                'hamlet_id' => $hamlet->id,
                'target_qty' => $request->target_qty
            ]);
        });
        
        return redirect()->route('hamlets.index')->with('success', 'Data berhasil disimpan.');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $hamlet = Hamlet::find($id);
        return view('admin.hamlets.edit', compact('hamlet'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
            $hamlet = Hamlet::find($id);
            
            $hamlet->hamlet_name = $request->hamlet_name;
            $hamlet->save();
        
        return redirect()->route('hamlets.index')->with('success', 'Data berhasil disimpan.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        DB::transaction(function () use($id){
            $targetMember = TargetMember::where('hamlet_id', $id)->first();
            $hamlet = Hamlet::find($id);

            $targetMember->delete();
            $hamlet->delete();
        });
        
        return redirect()->route('hamlets.index')->with('success', 'Data berhasil dihapus.');
    }
}

resources/views/admin/hamlets/create.blade.php
@extends('layouts.admin.main')
@section('content')
<div class="main-content">
  <section class="section">
    <div class="section-header">
      <h1>Dusun</h1>
      <div class="section-header-breadcrumb">
      <div class="breadcrumb-item active"><a href="{{ url('admin/dashboard') }}">Dashboard</a></div>
        <div class="breadcrumb-item"><a href="{{ url('admin/hamlets') }}">Dusun</a></div>
        <div class="breadcrumb-item">Tambah Dusun</div>
      </div>
    </div>

    <div class="section-body">
      <div class="row">
        <div class="col-12 col-md-8 col-lg-8">
          <div class="card">
            <form method="post" action="{{ route('hamlets.store') }}" class="needs-validation" novalidate="">
            @csrf
              <div class="card-header">
                <h4>Tambah Dusun</h4>
              </div>
              <div class="card-body">
                <div class="form-group">
                  <label>Nama Dusun</label>
                  <input type="text" class="form-control" name="hamlet_name" required="">
                  <div class="invalid-feedback">
                    Isian masih kosong
                  </div>
                </div>
                <div class="form-group">
                  <label>Target Pelanggan</label>
                  <input type="number" class="form-control" name="target_qty" required="">
                  <div class="invalid-feedback">
                    Isian masih kosong
                  </div>
                </div>
                <div class="card-footer text-right">
                  <button class="btn btn-primary">Submit</button>
                </div>
              </div>
            </form>
          </div>
        </div>
      </div>
    </div>
  </section>
</div>
@endsection

resources/views/admin/hamlets/edit.blade.php
@extends('layouts.admin.main')
@section('content')
<div class="main-content">
  <section class="section">
    <div class="section-header">
      <h1>Dusun</h1>
      <div class="section-header-breadcrumb">
        <div class="breadcrumb-item active"><a href="{{ url('admin/dashboard') }}">Dashboard</a></div>
        <div class="breadcrumb-item"><a href="{{ url('admin/hamlets') }}">Dusun</a></div>
        <div class="breadcrumb-item">Edit Dusun</div>
      </div>
    </div>

    <div class="section-body">
      <div class="row">
        <div class="col-12 col-md-8 col-lg-8">
          <div class="card">
            <form method="post" action="{{ route('hamlets.update', $hamlet->id) }}" class="needs-validation"
              novalidate="">@csrf
              {{ method_field('PUT') }}
              <div class="card-header">
                <h4>Edit Dusun</h4>
              </div>
              <div class="card-body">
                <div class="form-group">
                  <label>Nama Dusun</label>
                  <input type="text" class="form-control" name="hamlet_name" value="{{ $hamlet->hamlet_name }}"
                    required="">
                  <div class="invalid-feedback">
                    Isian masih kosong
                  </div>
                  <div class="card-footer text-right">
                    <button class="btn btn-primary">Submit</button>
                  </div>
            </form>
          </div>
        </div>
      </div>
    </div>
  </section>
</div>
@endsection

resources/views/admin/hamlets/index.blade.php
@extends('layouts.admin.main')
@section('content')
<div class="main-content">
  <section class="section">
    <div class="section-header">
      <h1>Dusun</h1>
      <div class="section-header-breadcrumb">
        <div class="breadcrumb-item"><a href="{{ url('admin/dashboard') }}">Dashboard</a></div>
        <div class="breadcrumb-item">Dusun</div>
      </div>
    </div>

    <div class="section-body">

      <div class="row">
        <div class="col-12">
          <div class="card">
            <div class="card-header">
              <h4>Data Dusun</h4>
            </div>
            <div class="card-body">
              <div>
                <a href="{{ route('hamlets.create') }}" class="btn btn-sm btn-primary mr-1 mb-3"><i
                    class="fas fa-plus"></i> Tambah Dusun</a>
              </div>
              <div class="table-responsive">
                <table class="table table-striped table-bordered" id="hamletTable">
                  <thead>
                    <tr>
                      <th class="text-center">
                        No.
                      </th>
                      <th>Nama Dusun</th>
                      <th>Aksi</th>
                    </tr>
                  </thead>
                  <tbody>
                    @foreach($hamlets as $hamlet)
                    <tr>
                      <td>{{ $loop->iteration }}</td>
                      <td>{{ $hamlet->hamlet_name }}</td>
                      <td>
                        <a href="{{ route('hamlets.edit', $hamlet) }}" class="btn btn-sm btn-warning mr-1"
                          data-toggle="tooltip" title="Edit"><i class="fas fa-pencil-alt"></i></a>
                        <form style="display: inline-block;" action="{{ route('hamlets.destroy', $hamlet) }}"
                          method="post">
                          @csrf @method('DELETE')
                          <button class="btn btn-sm btn-danger" type="submit" data-toggle="tooltip" title="Hapus">
                            <i class="fas fa-trash"></i></button>
                        </form>
                      </td>
                    </tr>
                    @endforeach
                  </tbody>
                </table>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
</div>
@endsection
@section('script')
@if (Session::has('success'))
<script>
iziToast.success({
  position: 'topRight',
  title: 'Sukses',
  message: '{{ Session::get("success") }}',
  timeout: 3000
});
</script>
@endif
<script>
$(document).ready(function() {
  $('#hamletTable').DataTable();
});
</script>
@endsection